.chat-view {
    -webkit-overflow-scrolling: touch;
    height: 100%;
    padding: 10px;
    font-size: 14px;
    /* background-color: #fff; */
    background-color: transparent;
    overflow-x: hidden;
    overflow-y: auto;
}

.chat-button {
    background-color: #fff;
    border: 1px solid #999;
    padding: 0.2rem 2rem;
    margin: 0.2rem;
}

.chat-button:hover {
    background-color: #efefef;
    cursor: pointer;
}

.chat-view::-webkit-scrollbar {
    width: 12px;
    height: 12px;
}

.chat-view::-webkit-scrollbar-thumb {
    background-color: rgba(0, 0, 0, 0.2);
}

.no-scrollbar {
    -ms-overflow-style: none;
    scrollbar-width: none;
}

.no-scrollbar::-webkit-scrollbar {
    display: none;
}

.chat-row {
    margin-bottom: 30px;
}

.chat-row .chat-time {
    display: inline-block;
    font-size: 0.8em;
    min-width: 40px;
    color: #999;
    vertical-align: bottom;
    margin-bottom: 5px;
}

.play-tts-button {
    color: #2196f3;
}

/* received */
.chat-received {
    position: relative;
}

.chat-received .received-profile {
    display: inline-block;
    vertical-align: top;
}

.chat-received .received-profile img {
    width: 32px;
    height: 32px;
}

.chat-received .received-bubble {
    display: inline-block;
    background-color: #eee;
    border-radius: 5px;
    border: 1px solid #eee;
    overflow: hidden;
}

.chat-received .received-isolation {
    padding: 0;
}

.chat-received .received-time-isolation {
    display: block;
    margin-top: 5px;
    text-align: right;
}

.chat-received .received-bubble .message-group {
    margin-top: 0;
}

.chat-received .received-bubble .message-container {
    margin-top: 1px;
}

.chat-received .received-bubble .message-container-first {
    margin-top: 0;
}

.chat-received .chat-emotion {
    display: inline-block;
    height: 32px;
    line-height: 32px;
    overflow: hidden;
    text-overflow: ellipsis;
    white-space: nowrap;
}

/* control-text */
.chat-received .control-text {
    padding: 0.7em;
    line-height: 1.3em;
}

/* control-button */
.chat-received .control-button {
    padding: 10px;
    cursor: pointer;
    text-align: center;
    background-color: #fff;
}

.chat-received .control-button-group .group-item {
    margin-top: 1px;
}

.chat-received .control-button-group .group-item-first {
    margin-top: 0;
}

/* control-button-link */
.chat-received .control-button-link {
    cursor: normal;
    text-decoration: none;
    overflow: hidden;
    margin: -10px;
    padding: 10px;
}

/* control-button-flow */
.chat-received .control-button-flow-group {
    padding: 10px;
}

.chat-received .control-button-flow-group .control-button-flow {
    display: inline-block;
    margin: 5px;
    padding: 10px;
    border: 1px solid #eee;
    cursor: pointer;
    border-radius: 3px;
}

.image-enlarge {
    position: fixed;
    top: 0px;
    left: 0px;
    width: 100%;
    height: 100%;
    z-index: 27;
    background-color: black;
    text-align: right;
}

.image-enlarge img {
    width: 100%;
    height: 100%;
    object-fit: contain;
}

/* sending */
.chat-sending {
    text-align: right;
}

.chat-sending .sending-bubble {
    display: inline-block;
    background-color: #333;
    color: #fff;
    text-align: left;
    border-radius: 5px;
    overflow: hidden;
    line-height: 0px;
}

.chat-sending .sending-text {
    padding: 0.7em;
    line-height: 1.3em;
}

.chat-sending.chat-sending-forbidden .sending-text {
    text-decoration: line-through;
}

/* chat-input */
.chat-input {
    border-top: 1px solid #ddd;
    background-color: #fff;
    overflow: hidden;
    height: 52px;
}

.chat-input-disabled {
    background-color: #ddd;
}

.chat-input .input-container {
    display: inline-block;
    position: 'relative';
    height: 100%;
}

.chat-input input {
    width: 100%;
    border: none;
    padding: 5px 10px;
    font-size: 14px;
    background: transparent;
}

.chat-input .input-button-container {
    display: inline-block;
    padding: 5px;
}

.chat-input .input-button {
    padding: 10px;
    cursor: pointer;
}

.chat-input .send-button {
    margin: 5px;
    width: 32px;
    height: 32px;
    vertical-align: middle;
    cursor: pointer;
}

.chat-attachment .chat-attachment-item {
    display: inline-block;
    position: relative;
}

.chat-attachment img {
    width: 50px;
    height: 50px;
    margin: 5px;
}

.chat-attachment .chat-attachment-remove-button {
    display: inline-block;
    background-color: #000;
    color: #fff;
    position: absolute;
    top: 0px;
    right: 0px;
    width: 15px;
    height: 15px;
    line-height: 15px;
    text-align: center;
    cursor: pointer;
}

/* auto-complete */
.chat-auto-complete {
    position: absolute;
    left: 0;
    right: 0;
    bottom: 0;
    max-height: 100%;
    overflow: auto;
    background-color: #fff;
    opacity: 0.9;
    font-size: 0.8em;
}

.chat-auto-complete-item {
    padding: 10px;
    cursor: pointer;
    background-color: #fff;
    color: #000;
}

.chat-auto-complete-item em {
    font-weight: bold;
    color: #f90;
}

/* date-divider */
.chat-date-divider {
    position: relative;
    border-top: 1px solid #999;
    margin: 20px -10px;
}

.chat-date-divider .divider-line {
    position: absolute;
    top: -20px;
    left: 0;
    right: 0;
    text-align: center;
}

.chat-date-divider .divider-content {
    display: inline-block;
    padding: 10px;
    background-color: #fff;
    font-size: 14px;
    white-space: nowrap;
}

/* carousel */
.control-carousel {
    /* overflow: hidden; */
    position: relative;
    margin-top: 15px;
    margin-bottom: 15px;
    margin-left: 0px;
    margin-right: 0px;
    background-color: transparent;
}

.control-carousel-card {
    width: 340px; /* px only*/
    padding-left: 20px;
    padding-right: 20px;
}

.control-carousel-card-first-child {
    padding-left: 39px;
    padding-right: 20px;
}
.control-carousel-card:first-child {
    padding-left: 39px;
    padding-right: 20px;
}

.control-carousel-card-item {
    overflow: hidden;
    background-color: #eee;
    color: #000;
    border-radius: 0px;
    border: 1px solid #eee;
}

.control-carousel-buttons {
    display: block;
    width: 100%;
    border: none;
    overflow: hidden;
}
.control-carousel-buttons button {
    border-style: solid;
    border-width: 0px 1px 1px 1px;
    border-color: #fff;
}
.control-carousel-buttons .btn-option {
    background: #fff;
    color: #000;
}

.control-carousel-buttons .btn-link {
    background: #fff;
    color: #000;
}

.control-carousel-buttons a:link,
.control-carousel-buttons a:visited,
.control-carousel-buttons a:hover,
.control-carousel-buttons a:active {
    text-decoration: none;
    color: inherit;
}

.control-carousel-button {
    display: block;
    height: 40px;
    width: 100%;
    border-top: 1px solid #eee;
    margin-left: 0px;
    font-size: 14px;
    line-height: 18px;
    cursor: pointer;
    overflow: hidden;
    white-space: nowrap;
    text-overflow: ellipsis;
}
.control-carousel-control {
    position: absolute;
    top: 50%;
    background-color: transparent;
    background-repeat: no-repeat;
    background-position: center center;
    -webkit-background-size: contain;
    -moz-background-size: contain;
    -o-background-size: contain;
    background-size: contain;
    width: 30px;
    height: 30px;
    border: none;
}
.control-carousel-image {
    display: block;
    width: 100%;
    background-color: transparent;
    background-repeat: no-repeat;
    background-position: center center;
    -webkit-background-size: cover;
    -moz-background-size: cover;
    -o-background-size: cover;
    background-size: cover;
    margin: auto;
}
.control-carousel-title {
    display: block;
    display: -webkit-box;
    width: 100%;
    height: 54px; /* px only*/
    word-break: break-all;
    line-clamp: 2;
    -webkit-line-clamp: 2;
    -webkit-box-orient: vertical;
    overflow: hidden;
    text-overflow: ellipsis;
    font-size: 14px;
    line-height: 20px;
    padding: 14px 24px 0px 24px;
}
.control-carousel-text {
    display: block;
    display: -webkit-box;
    width: 100%;
    white-space: pre-line;
    word-break: break-all;
    -webkit-box-orient: vertical;
    overflow: hidden;
    text-overflow: ellipsis;
    font-size: 14px;
    line-height: 20px;
    padding: 0px 24px 0px 24px;
    margin-bottom: 10px;
}
.control-carousel-text-html {
    display: block;
    width: 100%;
    word-break: keep-all;
    overflow: hidden;
    font-size: 14px;
    line-height: 20px;
}
.control-carousel-text-html img {
    display: inline;
}

.control-carousel-readmore {
    width: 100%;
    height: 100%;
    display: flex;
}

.control-carousel-readmore button {
    background-color: transparent;
    border: none;
    cursor: pointer;
}

@media (max-width: 360px) {
    .control-carousel-card {
        width: 221px;
        padding-left: 5px;
        padding-right: 5px;
    }
    .control-carousel-card-first-child {
        padding-left: 39px;
        padding-right: 5px;
    }
    .control-carousel-card:first-child {
        padding-left: 39px;
        padding-right: 5px;
    }
    .control-carousel-control {
        display: none;
    }
}
@media (max-width: 414px) and (min-width: 361px) {
    .control-carousel-card {
        width: 260px;
        padding-left: 5px;
        padding-right: 5px;
    }
    .control-carousel-card-first-child {
        padding-left: 39px;
        padding-right: 5px;
    }
    .control-carousel-card:first-child {
        padding-left: 39px;
        padding-right: 5px;
    }
    .control-carousel-control {
        display: none;
    }
}

/*control-image*/
.control-image {
    line-height: 0;
}

/* control-frame */
.control-frame {
    max-width: 100%;
}

.message-container > .control-frame {
    overflow-x: auto;
}

/*control-file-input*/
.control-file-input {
    display: none;
    width: 0px;
    height: 0px;
}

/* quick reply */
.chat-quick-reply {
    background-color: #ddd;
    padding: 5px;
    white-space: nowrap;
    overflow-y: auto;
}

.chat-quick-reply-button {
    display: inline-block;
    padding: 5px 15px;
    margin: 5px;
    background-color: #555;
    color: #fff;
    cursor: pointer;
    font-size: 12px;
    border-radius: 3px;
}

/* chat-loading */
.chat-loading-container {
    position: fixed;
    top: 0;
    left: 0;
    right: 0;
    bottom: 0;
}

.chat-loading-container .loading-item {
    position: absolute;
    top: 50px;
    left: 0;
    right: 0;
    text-align: center;
}

.chat-loading-container .loading-item img {
    width: 50px;
}

.chat-loading-container .loading-curtain {
    position: absolute;
    top: 0;
    left: 0;
    right: 0;
    bottom: 0;
    opacity: 0.5;
    /* background-color: #fff; */
}

/* bottoms */
.chat-bottoms-container {
    font-size: 14px;
}

.chat-frame-bottom-container {
    /* background-color: #fff; */
    background-color: transparent;
    border-top: 1px solid #eee;
}

.chat-buttons-bottom-container {
    /* background-color: #fff; */
    background-color: transparent;
}

.chat-buttons-bottom-stack-container .button-stack {
    padding: 10px;
    text-align: center;
    border-top: 1px solid #eee;
    cursor: pointer;
}

.chat-buttons-bottom-flow-container {
    background-color: #eee;
}

.chat-buttons-bottom-flow-container .button-flow {
    display: inline-block;
    padding: 5px 10px;
    margin: 5px;
    background-color: #fff;
    border-radius: 3px;
    cursor: pointer;
}

/* input pad */
.input-pad {
    background-color: #eee;
    height: 290px;
}

.message-pane {
    background-color: #eee;
}

.input-display {
    color: #000;
    background-color: #fff;
}

.keypad {
    background-color: #eee;
}
.keypad button {
    color: #2a2a2a;
    background-color: #fff;
}

.numpad {
    background-color: #eee;
}
.numpad button {
    color: #2a2a2a;
    background-color: #fff;
}

.pad-actions button {
    border-color: #eee;
    color: #2a2a2a;
    background-color: #fff;
}

#pad-action-submit {
    color: #fff;
    background-color: #323232;
}

.toast-container {
    position: fixed;
    left: 2em;
    right: 2em;
    bottom: 2em;
    text-align: center;
}

.toast {
    display: inline-block;
    padding: 1em 2em;
    background-color: #000;
    opacity: .7;
    color: white;
    border-radius: .3em;
    overflow: hidden;
}

/* chat-system */
.chat-row .chat-system {
    padding: 5px 10px;
    background-color: #ddd;
    text-align: center;
    margin: 0 -10px;
}

/* chat-feedback */
.chat-feedback-container {
    display: inline-block;
    width: 80%;
    background-color: #fff;
}

.chat-feedback-info-text {
    padding: 5px;
    text-align: left;
}

.chat-feedback-grade-container {
    padding: 10px;
}

.chat-feedback-grade-star {
    display: inline-block;
    padding: 10px;
    font-size: 2em;
    cursor: pointer;
}

.chat-feedback-grade-star-on {
    color: #f8d64e;
}

.chat-feedback-grade-star-off {
    color: #ddd;
}

.chat-feedback-resolve-container {
    padding: 10px;
}

.chat-feedback-resolve-value-container {
    margin-top: 10px;
}

.chat-feedback-comment-container {
    padding: 10px;
}

.chat-feedback-comment-max-bytes {
    font-size: 0.7em;
    text-align: right;
}

.chat-feedback-comment-container textarea {
    width: 100%;
    padding: 5px;
    border: 1px solid #333;
    resize: none;
}

.chat-feedback-buttons-container {
    margin-top: 20px;
    display: flex;
}

.chat-feedback-send-button {
    width: 50%;
    height: 40px;
    line-height: 40px;
    text-align: center;
    background-color: #2d77d6;
    color: #fff;
    cursor: pointer;
}

.chat-feedback-send-button.send-disabled {
    opacity: 0.5;
}

.chat-feedback-cancel-button {
    width: 50%;
    height: 40px;
    line-height: 40px;
    text-align: center;
    background-color: #666666;
    color: #fff;
    cursor: pointer;
}

.chat-livechat-disconnected-popup {
    position: absolute;
    top: 0;
    left: 0;
    right: 0;
}

.chat-livechat-disconnected-popup > div {
    padding: 15px;
    background-color: #000;
    opacity: 0.8;
    color: #fff;
    line-height: 1.5em;
}

.dialog-feedback-button {
    padding: 10px;
    text-align: center;
    background-color: #fff;
    cursor: pointer;
    margin: 2px;
}

.again-popup {
    display: inline-block;
    background-color: #fff;
    min-width: 80%;
}

.again-popup-message {
    padding: 1rem;
    text-align: left;
}

.again-popup-buttons {
    padding: 0.5rem;
    text-align: right;
}

.visually-hidden {
    border: 0;
    clip: rect(0 0 0 0);
    height: 1px;
    margin: -1px;
    overflow: hidden;
    padding: 0;
    position: absolute;
    width: 1px;
}
.chat-locationpicker-container {
    width: 100%;
    height: 100%;
    display: flex;
    flex-direction: column;
}
.chat-locationpicker-map {
    width: 100%;
    height: 100%;
}
.chat-locationpicker-buttons-container {
    display: flex;
    justify-content: center;
}
.chat-locationpicker-send-button {
    width: 100%;
    cursor: pointer;
    background: #2d77d6;
    color: #fff;
    height: 40px;
    line-height: 40px;
}
.chat-locationpicker-send-button.disabled{
    pointer-events: none;
    cursor: not-allowed;
    opacity: 0.5;
}
.chat-locationpicker-cancel-button {
    width: 100%;
    cursor: pointer;
    background: #fff;
    height: 40px;
    line-height: 40px;
}
.chat-locationpicker-error-container {
    height: 100%;
    display: flex;
    flex-direction: column;
    justify-content: center;
    align-items: center;
}
.chat-locationpicker-error-container > div {
    width: 80%;
}
.chat-locationpicker-error-button {
    overflow: hidden;
    height: 40px;
    line-height: 40px;
    text-align: center;
    background-color: #666666;
    color: #fff;
    cursor: pointer;
}
.chat-map-infowindow {
    white-space: nowrap;
}

.livechat-feedback-comment {
    margin-top: 2em;
}

/* markdown */
.cg-codeblock {
    border-radius:.5em;
    overflow:hidden;
}

.cg-codeblock-header {
    padding: .5em 1em;
    background-color: #000;
    color: white;
    display: flex;
}

.cg-codeblock-title {
    flex-grow: 1;
}

.cg-hidden-link {
    display: none;
    width: 0;
    height: 0;
}

.cg-codeblock-button {
    cursor: pointer;
    font-size: 1em;
}

.cg-codeblock-download {
    margin-left: 1em;
}

.control-markdown {
    padding: 1em;
    border: 1px solid #ddd;
    border-radius: .5em;
}
